# INDEX.RL

TITLE Case Indexing Knowledge Base

$INCLUDE global.dcl
$INCLUDE index.dcl


GOAL     case index found

#
RULE     living dining requirements 1
IF       requirement IS living cum dining
THEN     living dining requirements IS LivingCumDining

#
RULE     living dining requirements 2
IF       requirement IS living alone
THEN     living dining requirements IS Living

#
RULE     living dining requirements 3
IF       requirement IS dining alone
THEN     living dining requirements IS Dining

#
RULE     for side A
IF       there is a road along side A
THEN     FINSERT_VAL UserRequirements, RoadPositions, 1, yes
AND      side A examined
ELSE     FINSERT_VAL UserRequirements, RoadPositions, 1, no
AND      side A examined

#
RULE     for side B
IF       there is a road along side B
THEN     FINSERT_VAL UserRequirements, RoadPositions, 2, yes
AND      side B examined
ELSE     FINSERT_VAL UserRequirements, RoadPositions, 2, no
AND      side B examined

#
RULE     for side C
IF       there is a road along side C
THEN     FINSERT_VAL UserRequirements, RoadPositions, 3, yes
AND      side C examined
ELSE     FINSERT_VAL UserRequirements, RoadPositions, 3, no
AND      side C examined

#
RULE     for side D
IF       there is a road along side D
THEN     FINSERT_VAL UserRequirements, RoadPositions, 4, yes
AND      side D examined
ELSE     FINSERT_VAL UserRequirements, RoadPositions, 4, no
AND      side D examined

#
RULE     for roads adjacent 1
IF       roads adjacent to residence IS yes
AND      FADD_ATTR UserRequirements, FSTRING, RoadPositions
AND      DISPLAY figure
AND      side A examined
AND      side B examined
AND      side C examined
AND      side D examined
THEN     road information read

#
RULE     for roads adjacent 2
IF       roads adjacent to residence IS no
THEN     road information read

#
RULE     for verandah info
IF       verandah IS yes
AND      FADD_ATTR Residence, FSTRING, Verandah
AND      FINSERT_VAL  Residence, Verandah, 1, Verandah
AND      FCREATE_FRAME Verandah
AND      FADD_ATTR Verandah, FDOUBLE, Length
AND      FADD_ATTR Verandah, FDOUBLE, Breadth
AND      FINSERT_VAL Verandah, VerandahLength, 1, verandah length
AND      FINSERT_VAL Verandah, VerandahBreadth, 1, verandah breadth
THEN     verandah information read

#
RULE     for verandah info 2
IF       verandah IS no
THEN     verandah information read

#
RULE     for bath details 1
IF       independent bathrooms IS yes
AND      FADD_ATTR UserRequirements, FINTEGER, NoOfBaths
AND      FINSERT_VAL UserRequirements, NoOfBaths, 1, number of baths
THEN     bathroom details read

#
RULE     for bath details 2
IF       independent bathrooms IS no
THEN     bathroom details read

#
RULE     creating UserRequirements
IF       FCREATE_FRAME UserRequirements
AND      FADD_ATTR  UserRequirements, FINTEGER, NumberOfBeds
AND      FADD_ATTR  UserRequirements, FDOUBLE, FundsAvailable
AND      FADD_ATTR  UserRequirements, FDOUBLE, PlotLength
AND      FADD_ATTR  UserRequirements, FDOUBLE, PlotBreadth
AND      FADD_ATTR  UserRequirements, FDOUBLE, BuildingLength
AND      FADD_ATTR  UserRequirements, FDOUBLE, BuildingBreadth
AND      FADD_ATTR  UserRequirements, FDOUBLE, SizeOfKitchen
AND      FADD_ATTR  UserRequirements, FSTRING, LivingDiningRequirements
AND      FADD_ATTR  UserRequirements, FSTRING, RoadsAdjacentToResidence
AND      FADD_ATTR  UserRequirements, FSTRING, Verandah
AND      FADD_ATTR  UserRequirements, FSTRING, Bath
AND      FINSERT_VAL UserRequirements, NumberOfBeds, 1, number of beds
AND      FINSERT_VAL UserRequirements, FundsAvailable, 1, funds available
AND      FINSERT_VAL UserRequirements, PlotLength, 1, plot length
AND      FINSERT_VAL UserRequirements, PlotBreadth, 1, plot breadth
AND      FINSERT_VAL UserRequirements, BuildingLength, 1, building length
AND      FINSERT_VAL UserRequirements, BuildingBreadth, 1, building breadth
AND      FINSERT_VAL UserRequirements, SizeOfKitchen, 1, size of kitchen
AND      FINSERT_VAL UserRequirements, LivingDiningRequirements, 1, living dining requirements
AND      FINSERT_VAL UserRequirements,  RoadsAdjacentToResidence, 1, roads adjacent to residence
AND      road information read
AND      FINSERT_VAL UserRequirements,  Verandah, 1, verandah
AND      verandah information read
AND      FADD_ATTR Residence, FDOUBLE, PlotSize
AND      FADD_ATTR Residence, FDOUBLE, PlinthArea
AND      FINSERT_VAL Residence, PlotSize, 1, FRAME(UserRequirements, PlotLength, 1) * FRAME(UserRequirements, PlotBreadth, 1)
AND      FINSERT_VAL Residence, PlinthArea, 1, FRAME(UserRequirements, BuildingLength, 1) * FRAME(UserRequirements, BuildingBreadth, 1)
AND      FINSERT_VAL UserRequirements,  Bath, 1, independent bathrooms
AND      bathroom details read
THEN     user requirements are stored in framebase

#
RULE     two bed room
IF       FADD_ATTR  UserRequirements, FDOUBLE, AreaOfBed1
AND      FINSERT_VAL UserRequirements, AreaOfBed1, 1, area of bed 1
AND      FADD_ATTR  UserRequirements, FDOUBLE, AreaOfBed2
AND      FINSERT_VAL UserRequirements, AreaOfBed2, 1, area of bed 2
AND      number of beds == 2
THEN     bed room sizes obtained

# The system assumes that the bed room sizes will be entered in ascending
# order of the values of their area.
#
RULE     three bed room
IF       FADD_ATTR  UserRequirements, FDOUBLE, AreaOfBed3
AND      FINSERT_VAL UserRequirements, AreaOfBed3, 1, area of bed 3
AND      number of beds == 3
THEN     bed room sizes obtained

#
RULE     four bed room
IF       FADD_ATTR  UserRequirements, FDOUBLE, AreaOfBed4
AND      FINSERT_VAL UserRequirements, AreaOfBed4, 1, area of bed 4
AND      number of beds == 4
THEN     bed room sizes obtained

#
RULE     five bed room
IF       FADD_ATTR  UserRequirements, FDOUBLE, AreaOfBed5
AND      FINSERT_VAL UserRequirements, AreaOfBed5, 1, area of bed 5
THEN     bed room sizes obtained


#
RULE     for number of bedrooms
IF       ASK couples
AND      ASK unmarried adults
AND      ASK children
THEN     number of beds = couples + unmarried adults + children / 2

#
RULE     goal rule 1
IF       number of beds == 2
AND      funds available >= 0.2
AND      funds available <= 0.3
AND      user requirements are stored in framebase
AND      bed room sizes obtained
THEN     case index IS type1
AND      case index found
AND      LOAD control

#
RULE     goal rule 2
IF       number of beds == 3
AND      funds available > 0.3
AND      funds available <= 0.4
AND      user requirements are stored in framebase
AND      bed room sizes obtained
THEN     case index IS type2
AND      case index found
AND      LOAD control

#
RULE     goal rule 3a
IF       number of beds == 4
AND      funds available > 0.4
AND      funds available <= 0.5
AND      user requirements are stored in framebase
AND      bed room sizes obtained
THEN     case index IS type3_4
AND      case index found
AND      LOAD control

#
RULE     goal rule 3b
IF       number of beds == 5
AND      funds available > 0.4
AND      funds available <= 0.5
AND      user requirements are stored in framebase
AND      bed room sizes obtained
THEN     case index IS type3_5
AND      case index found
AND      LOAD control

#
RULE     goal rule 4
IF       DISPLAY NoIndex
THEN NOT case index found
AND      LOAD control

$INCLUDE index.inf

END
