# RETRIEV.RL

TITLE Case Retriever

$INCLUDE global.dcl
$INCLUDE retriev.dcl

GOAL     cases retrieved

#
RULE     cheking for case card
IF       CBR_load_case_card(case index) == 1
THEN     case card is available
ELSE NOT case card is available
AND      DISPLAY NoCaseCard

#
RULE     for living dining requirements ranges
IF       FADD_ATTR range frame, FSTRING, LivingDiningRequirements
AND      FINSERT_VAL range frame, LivingDiningRequirements, 1, FRAME(UserRequirements, LivingDiningRequirements, 1)
AND      FINSERT_VAL range frame, LivingDiningRequirements, 2, FRAME(UserRequirements, LivingDiningRequirements, 1)
THEN     ranges for living dining requirements are set

#
RULE     for for plot size ranges
IF       FADD_ATTR  range frame, FDOUBLE, PlotSize
AND      FINSERT_VAL range frame, PlotSize, 1, FRAME(Residence, PlotSize, 1)
AND      FINSERT_VAL range frame, PlotSize, 2, FRAME(Residence, PlotSize, 1) * 0.9 
AND      FINSERT_VAL range frame, PlotSize, 3, FRAME(Residence, PlotSize, 1) * 1.1
# 90% of actual value to 10% more
THEN     ranges for plot size are set

#
RULE     for plinth area rages
IF       FADD_ATTR  range frame, FDOUBLE, PlinthArea
AND      FINSERT_VAL ranfe frame, PinthArea, 1, FRAME(Residence, PlinthArea, 1)
AND      FINSERT_VAL ranfe frame, PinthArea, 2, FRAME(Residence, PlinthArea, 1)
AND      FINSERT_VAL ranfe frame, PinthArea, 3, FRAME(Residence, PlinthArea, 1) * 1.1
# actual value to 10% more
THEN     ranges for plinth area are set

#
RULE     for kitchen size ranges
IF       FADD_ATTR  range frame, FDOUBLE, SizeOfKitchen
AND      FINSERT_VAL range frame, SizeOfKitchen, 1, FRAME(UserRequirements, SizeOfKitchen, 1)
AND      FINSERT_VAL range frame, SizeOfKitchen, 2, FRAME(UserRequirements, SizeOfKitchen, 1) * 0.95
AND      FINSERT_VAL range frame, SizeOfKitchen, 3, FRAME(UserRequirements, SizeOfKitchen, 1) * 1.05
# 95% of actual value to 5% more
THEN     ranges for kitchen are set

/**********************************************************************
Comment for me - H. Shiva Kumar
A feature is needed in CASETOOL which enables avoiding the confusion
of the order of these attributes (See assumption in INDEX.RL)
these three variables need to be grouped such that an exhaustive
search will be made irrespective of their order
**********************************************************************/

#
RULE     two bed room
IF       FADD_ATTR  range frame, FDOUBLE, AreaOfBed1
AND      FINSERT_VAL range frame, AreaOfBed1, 1, FRAME(UserRequirements, AreaOfBed1, 1)
AND      FINSERT_VAL range frame, AreaOfBed1, 2, FRAME(UserRequirements, AreaOfBed1, 1) * 0.95
AND      FINSERT_VAL range frame, AreaOfBed1, 3, FRAME(UserRequirements, AreaOfBed1, 1) * 1.05
# 95% of actual value to 5% more
AND      FADD_ATTR  range frame, FDOUBLE, AreaOfBed2
AND      FINSERT_VAL range frame, AreaOfBed2, 1, FRAME(UserRequirements, AreaOfBed2, 1)
AND      FINSERT_VAL range frame, AreaOfBed2, 2, FRAME(UserRequirements, AreaOfBed2, 1) * 0.95
AND      FINSERT_VAL range frame, AreaOfBed2, 3, FRAME(UserRequirements, AreaOfBed2, 1) * 1.05
# 95% of actual value to 5% more
AND      FRAME(UserRequirements, NumberOfBeds, 1) == 2
THEN     ranges for bedroom sizes are set

#
RULE     three bed room
IF       FADD_ATTR  range frame, FDOUBLE, AreaOfBed3
AND      FINSERT_VAL range frame, AreaOfBed3, 1, FRAME(UserRequirements, AreaOfBed3, 1)
AND      FINSERT_VAL range frame, AreaOfBed3, 2, FRAME(UserRequirements, AreaOfBed3, 1) * 0.95
AND      FINSERT_VAL range frame, AreaOfBed3, 3, FRAME(UserRequirements, AreaOfBed3, 1) * 1.05
# 95% of actual value to 5% more
AND      FRAME(UserRequirements, NumberOfBeds, 1) == 3
THEN     ranges for bedroom sizes are set

#
RULE     four bed room
IF       FADD_ATTR  range frame, FDOUBLE, AreaOfBed4
AND      FINSERT_VAL range frame, AreaOfBed4, 1, FRAME(UserRequirements, AreaOfBed4, 1)
AND      FINSERT_VAL range frame, AreaOfBed4, 2, FRAME(UserRequirements, AreaOfBed4, 1) * 0.95
AND      FINSERT_VAL range frame, AreaOfBed4, 3, FRAME(UserRequirements, AreaOfBed4, 1) * 1.05
# 95% of actual value to 5% more
AND      FRAME(UserRequirements, NumberOfBeds, 1) == 4
THEN     ranges for bedroom sizes are set

#
RULE     five bed room
IF       FADD_ATTR  range frame, FDOUBLE, AreaOfBed5
AND      FINSERT_VAL range frame, AreaOfBed5, 1, FRAME(UserRequirements, AreaOfBed5, 1)
AND      FINSERT_VAL range frame, AreaOfBed5, 2, FRAME(UserRequirements, AreaOfBed5, 1) * 0.95
AND      FINSERT_VAL range frame, AreaOfBed5, 3, FRAME(UserRequirements, AreaOfBed5, 1) * 1.05
# 95% of actual value to 5% more
THEN     ranges for bedroom sizes are set

#
RULE     for setting ranges for selection stage
IF       FCREATE_FRAME range frame
AND      FADD_ATTR range frame, FINTEGER, GROUP_NUM
AND      FINSERT_VAL range frame, GROUP_NUM, 1, 1
AND      ranges for living dining requirements are set
AND      ranges for plot size are set
AND      ranges for plinth area are set
AND      ranges for kitchen are set
AND      ranges for bedroom sizes are set
AND      CBR_set_ranges(range frame) == 1
THEN     ranges are set for selection stage

/**********************************************************************
relevance stage also needs ranges to be set for attributes. Since
most of the attribute of the above stage appear in this stage too,
it is enough to modify the GROUP_NUM to 2 (since the second group
is relevance group), delete those attributes that do not appear here,
and add those that did not appear before.
**********************************************************************/

#
RULE     for setting ranges for relevance stage
IF       FMOD_POS range frame, GROUP_NUM, 1, 2
AND      FDEL_ATTR range frame, LivingDiningRequirements
AND      CBR_set_ranges(range frame) == 1
THEN     ranges are set for relevance stage


/**********************************************************************
Recreating the "range frame" again causes the old values etc. to be
removed. The ranges are set as below
**********************************************************************/

#
RULE     for setting ranges for performance stage
IF       FCREATE_FRAME frame
AND      FADD_ATTR frame, FINTEGER, GROUP_NUM
AND      FINSERT_VAL frame, GROUP_NUM, 1, 3
AND      FADD_ATTR range frame, FDOUBLE, Rating
AND      FINSERT_VAL range frame, Rating, 1, 80.0
AND      FINSERT_VAL range frame, Rating, 2, 60.0
AND      FINSERT_VAL range frame, Rating, 3, 40.0
AND      CBR_set_performance_ranges(range frame) == 1
THEN     ranges are set for performance stage

#
RULE     relevance conditions
IF       CBR_set_relevance_conditions(2, 0.3, 1.0) == 1     # 0.0-0.3 time RNmax => perfect match
THEN     relevance conditions are set                       # > 0.3-1.0 time RNmax => close match

#
RULE     performance conditions
IF       CBR_set_performacne_conditions(3, 80, 60, 40) == 1 # 80-100 vg; 60-80 g; 40-60 a; 0-40b;
THEN     performance conditions are set

#
RULE     for seach conditions are set
IF       ranges are set for selection stage
AND      ranges are set for relevance stage
AND      ranges are set for performance stage
AND      relevance conditions are set
AND      performance conditions are set
THEN     seach conditions are set

#
RULE     for number of retrieved cases
IF       seach conditions are set
THEN     number of retrieved cases = CBR_search_case_card()

#
RULE     for cheking the availability of cases
IF       number of retrieved cases > 0
THEN     cases available
ELSE NOT cases available
AND      DISPLAY NoCases

#
RULE     goal rule 1
IF       case card is available
AND      cases available
THEN     cases retrieved
AND      LOAD control
ELSE NOT cases retrieved
AND      LOAD control

$INCLUDE retriev.inf

END
