TITLE expert system for Bearing Selection

BOOLEAN
silent running important, presence of shaft misalignment with housing,
moderate axial loading, heavy radial loading, moderate radial loading,
light radial loading, silent normal environment, noisy normal environment,
silent clean environment, silent running needed, high speed shaft, 
medium speed shaft, low speed shaft and housing, bearing is selected

STRING
loading type, loading class, dominant load component,
running speed, rotating part

GOAL bearing is selected

#1
RULE	moderate axial loading
IF	loading class IS moderate
AND	dominant load component IS axial
THEN	moderate axial loading

#2
RULE	heavy radial loading
IF	loading class IS heavy
AND	dominant load component IS radial
THEN	heavy radial loading

#3
RULE	moderate radial loading
IF	loading class IS moderate
AND	dominant load component IS radial
THEN	moderate radial loading

#4
RULE	light axial loading
IF	loading class IS light
AND	dominant load component IS radial
THEN	light radial loading

#5
RULE	silent normal
IF	silent running needed
AND	working environment IS normal
THEN	silent normal environment

#6
RULE	noisy normal
IF NOT	silent running needed
AND	working environment IS normal
THEN	noisy normal environment

#7
RULE	silent clean
IF 	silent running needed
AND	working environment IS clean
THEN	silent clean environment

#8
RULE	high shaft
IF 	running speed IS high
AND	rotating part IS shaft
THEN	high speed shaft

#9
RULE	medium shaft
IF 	running speed IS medium
AND	rotating part IS shaft
THEN	medium speed shaft

#10
RULE	low shaft and housing
IF 	running speed IS low
AND	rotating part IS shaft and housing
THEN	low speed shaft and housing

#11
RULE	bearing type_1
IF	loading type IS radial and axial
AND	presence of shaft misalignment with housing
AND	moderate axial loading
AND	high speed shaft
AND	silent normal environment
THEN	bearing is selected
AND	DISPLAY type_1

#12
RULE	bearing type_2
IF	loading type IS radial and axial
AND NOT	presence of shaft misalignment with housing
AND	heavy radial loading
AND	high speed shaft
AND	noisy normal environment
THEN	bearing is selected
AND	DISPLAY type_2

#13
RULE	bearing type_3
IF	loading type IS radial
AND NOT	presence of shaft misalignment with housing
AND	light radial loading
AND	medium speed shaft
AND	silent clean environment
THEN	bearing is selected
AND	DISPLAY type_3

#14
RULE	bearing type_4
IF	loading type IS radial and axial
AND 	presence of shaft misalignment with housing
AND	moderate radial loading
AND	medium speed shaft
AND	noisy normal environment
THEN	bearing is selected
AND	DISPLAY type_4

#15
RULE	bearing type_5
IF	loading type IS radial and axial
AND 	presence of shaft misalignment with housing
AND	heavy radial loading
AND	low speed shaft and housing
AND	noisy normal environment
THEN	bearing is selected
AND	DISPLAY type_5

#16
RULE	bearing type_6
IF	loading type IS radial and axial
AND NOT	presence of shaft misalignment with housing
AND	moderate radial loading
AND	high speed shaft
AND	noisy normal environment
THEN	bearing is selected
AND	DISPLAY type_6

END